#ifndef __rf_channel_hh__
#define __rf_channel_hh__

#include "rf_types.hh"
#include "rf_object.hh"
#include <stdio.h>

namespace rftype
{

using namespace rfrt ;

class Channel :
  public Object
{

private:

  FILE* fp ;
//  bool was_opened ;

  static ObjectRegister reg ;

  NO_COPY_CTOR(Channel)

public:

  inline Channel (FILE* _fp = null) ;
  inline ~Channel () ;
  inline Channel& operator = (Channel const& _channel) ;

  inline unsigned get_type () const ;
  inline uint32_t hash () const ;

  inline pxx::WString to_string () const ;

  inline bool open (char const* _fname, char const* _mode) ;
  inline void close () ;
  inline bool eof();
  inline FILE* get_fp () const ;

};

}

#endif // __rf_channel_hh__
