// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Пт, 15 дек 2006) $
// $Author: orlov $

#ifndef __rf_static_object_hh__
#define __rf_static_object_hh__

#include "pxx_string.hh"
#include "rf_common.hh"

namespace rftype
{

template<class ObjClass>
class StaticObject : public ObjClass
{

  wchar_t const* name;
  size_t  const  length;

  NO_COPY_CTOR(StaticObject)
  NO_ASSIGN(StaticObject)

public:

  inline StaticObject (
      ObjClass const& _obj, wchar_t const* _name, size_t _length) ;

  inline StaticObject (ObjClass const& _obj, wchar_t const* _name) ;

  inline StaticObject (wchar_t const* _name) ;

  inline ~StaticObject () ;

  inline void* operator new (size_t _size) ;
  inline void  operator delete (void* _ptr) ;

  virtual inline pxx::WString to_string () const;
  
  virtual inline size_t get_name (wchar_t const** _name) const;
};

}

#endif // __rf_static_object_hh__

